Crazy Eddies GUI System: CEGUI::Spinner Class Reference

- Main Page
- Namespaces
- Classes
- Files
- Directories
- Related Pages

- Class List
- Alphabetical List
- Class Hierarchy
- Class Members

# CEGUI::Spinner Class Reference

Base class for the Spinner widget. More...

Inheritance diagram for CEGUI::Spinner:

[legend]
Collaboration diagram for CEGUI::Spinner:

[legend]
List of all members.

## Public Types
enum | TextInputMode { FloatingPoint, Integer, Hexadecimal, Octal }
| Enumerated type specifying possible input and/or display modes for the spinner. More...
## Public Member Functions
| Spinner (const String &type, const String &name)
| Constructor for Spinner objects.
virtual | ~Spinner (void)
| Destructor for Spinner objects.
void | initialise (void)
| Initialises the Window based object ready for use.
float | getCurrentValue (void) const
| Return the current spinner value.
float | getStepSize (void) const
| Return the current step value.
float | getMaximumValue (void) const
| Return the current maximum limit value for the Spinner.
float | getMinimumValue (void) const
| Return the current minimum limit value for the Spinner.
TextInputMode | getTextInputMode (void) const
| Return the current text input / display mode setting.
void | setCurrentValue (float value)
| Set the current spinner value.
void | setStepSize (float step)
| Set the current step value.
void | setMaximumValue (float maxValue)
| Set the spinner maximum value.
void | setMinimumValue (float minVaue)
| Set the spinner minimum value.
void | setTextInputMode (TextInputMode mode)
| Set the spinner input / display mode.
## Static Public Attributes
static const String | EventNamespace
| Namespace for global events.
static const String | EventValueChanged
| Event fired when the spinner value changes.
static const String | EventStepChanged
| Event fired when the step value changes.
static const String | EventMaximumValueChanged
| Event fired when the maximum spinner value changes.
static const String | EventMinimumValueChanged
| Event fired when the minimum spinner value changes.
static const String | EventTextInputModeChanged
| Event fired when the input/display mode is changed.
## Protected Member Functions
void | addSpinnerEvents (void)
| Adds events specific to the Spinner base class.
virtual float | getValueFromText (void) const
| Returns the numerical representation of the current editbox text.
virtual String | getTextFromValue (void) const
| Returns the textual representation of the current spinner value.
virtual bool | testClassName_impl (const String &class_name) const
| Return whether this window was inherited from the given class name at some point in the inheritance heirarchy.
virtual PushButton * | createIncreaseButton (const String &name) const =0
| Creates a PushButton based widget that will be used for the increase button component of the Spinner widget.
virtual PushButton * | createDecreaseButton (const String &name) const =0
| Creates a PushButton based widget that will be used for the decrease button component of the Spinner widget.
virtual Editbox * | createEditbox (const String &name) const =0
| Creates an Editbox based widget that will be used for the text input area of the spinner widget.
virtual void | onFontChanged (WindowEventArgs &e)
| Handler called when the window's font is changed.
virtual void | onTextChanged (WindowEventArgs &e)
| Handler called when the window's text is changed.
virtual void | onActivated (ActivationEventArgs &e)
| Handler called when this window has become the active window.
virtual void | onValueChanged (WindowEventArgs &e)
| Method called when the spinner value changes.
virtual void | onStepChanged (WindowEventArgs &e)
| Method called when the step value changes.
virtual void | onMaximumValueChanged (WindowEventArgs &e)
| Method called when the maximum value setting changes.
virtual void | onMinimumValueChanged (WindowEventArgs &e)
| Method called when the minimum value setting changes.
virtual void | onTextInputModeChanged (WindowEventArgs &e)
| Method called when the text input/display mode is changed.
bool | handleIncreaseButton (const EventArgs &e)
bool | handleDecreaseButton (const EventArgs &e)
bool | handleEditTextChange (const EventArgs &e)
## Protected Attributes
PushButton * | d_increaseButton
| Pointer to the increase button widget.
PushButton * | d_decreaseButton
| Pointer to the decrease button widget.
Editbox * | d_editbox
| Pointer to the editbox widget.
float | d_stepSize
| Step size value used y the increase & decrease buttons.
float | d_currentValue
| Numerical copy of the text in d_editbox.
float | d_maxValue
| Maximum value for spinner.
float | d_minValue
| Minimum value for spinner.
TextInputMode | d_inputMode
| Current text display/input mode.
## Static Protected Attributes
static const String | FloatValidator
| Validator regex used for floating point mode.
static const String | IntegerValidator
| Validator regex used for decimal integer mode.
static const String | HexValidator
| Validator regex used for hexadecimal mode.
static const String | OctalValidator
| Validator regex used for octal mode.

## Detailed Description

Base class for the Spinner widget.

The spinner widget has a text area where numbers may be entered and two buttons which may be used to increase or decrease the value in the text area by a user specified amount.

## Member Enumeration Documentation

enum CEGUI::Spinner::TextInputMode

  | Enumerated type specifying possible input and/or display modes for the spinner. Enumerator:
  FloatingPoint | Floating point decimal.
  Integer | Integer decimal.
  Hexadecimal | Hexadecimal.
  Octal | Octal.

## Member Function Documentation

void CEGUI::Spinner::addSpinnerEvents | ( | void |  | ) | `[protected]`

| Adds events specific to the Spinner base class. Returns: Nothing.

virtual PushButton* CEGUI::Spinner::createDecreaseButton | ( | const String & | name | ) | const`[protected, pure virtual]`

| Creates a PushButton based widget that will be used for the decrease button component of the Spinner widget. Returns: Pointer to a valid PushButton based object.

virtual Editbox* CEGUI::Spinner::createEditbox | ( | const String & | name | ) | const`[protected, pure virtual]`

| Creates an Editbox based widget that will be used for the text input area of the spinner widget. Returns: Pointer to a valid Editbox based object.

virtual PushButton* CEGUI::Spinner::createIncreaseButton | ( | const String & | name | ) | const`[protected, pure virtual]`

| Creates a PushButton based widget that will be used for the increase button component of the Spinner widget. Returns: Pointer to a valid PushButton based object.

float CEGUI::Spinner::getCurrentValue | ( | void |  | ) | const

| Return the current spinner value. Returns: current float value of the Spinner.

float CEGUI::Spinner::getMaximumValue | ( | void |  | ) | const

| Return the current maximum limit value for the Spinner. Returns: Maximum value that is allowed for the spinner.

float CEGUI::Spinner::getMinimumValue | ( | void |  | ) | const

| Return the current minimum limit value for the Spinner. Returns: Minimum value that is allowed for the spinner.

float CEGUI::Spinner::getStepSize | ( | void |  | ) | const

| Return the current step value. Returns: float step value. This is the value added to the spinner vaue when the up / down buttons are clicked.

String CEGUI::Spinner::getTextFromValue | ( | void |  | ) | const`[protected, virtual]`

| Returns the textual representation of the current spinner value. Returns: String object that is equivalent to the the numerical value of the spinner.

Spinner::TextInputMode CEGUI::Spinner::getTextInputMode | ( | void |  | ) | const

| Return the current text input / display mode setting. Returns: One of the TextInputMode enumerated values indicating the current text input and display mode.

float CEGUI::Spinner::getValueFromText | ( | void |  | ) | const`[protected, virtual]`

  | Returns the numerical representation of the current editbox text. Returns: float value that is the numerical equivalent of the editbox text. Exceptions:
  | InvalidRequestException | thrown if the text can not be converted.

void CEGUI::Spinner::initialise | ( | void |  | ) | `[virtual]`

| Initialises the Window based object ready for use. Note: This must be called for every window created. Normally this is handled automatically by the WindowFactory for each Window type. Returns: Nothing Reimplemented from CEGUI::Window.

void CEGUI::Spinner::onActivated | ( | ActivationEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when this window has become the active window. Parameters:
  | e | ActivationEventArgs class whose 'otherWindow' field is set to the window that previously was active, or NULL for none.
Reimplemented from CEGUI::Window.

void CEGUI::Spinner::onFontChanged | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when the window's font is changed. Parameters:
  | e | WindowEventArgs object whose 'window' pointer field is set to the window that triggered the event. For this event the trigger window is always 'this'.
Reimplemented from CEGUI::Window.

void CEGUI::Spinner::onMaximumValueChanged | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

  | Method called when the maximum value setting changes. Parameters:
  | e | WindowEventArgs object containing any relevant data.
Returns: Nothing.

void CEGUI::Spinner::onMinimumValueChanged | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

  | Method called when the minimum value setting changes. Parameters:
  | e | WindowEventArgs object containing any relevant data.
Returns: Nothing.

void CEGUI::Spinner::onStepChanged | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

  | Method called when the step value changes. Parameters:
  | e | WindowEventArgs object containing any relevant data.
Returns: Nothing.

void CEGUI::Spinner::onTextChanged | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when the window's text is changed. Parameters:
  | e | WindowEventArgs object whose 'window' pointer field is set to the window that triggered the event. For this event the trigger window is always 'this'.
Reimplemented from CEGUI::Window.

void CEGUI::Spinner::onTextInputModeChanged | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

  | Method called when the text input/display mode is changed. Parameters:
  | e | WindowEventArgs object containing any relevant data.
Returns: Nothing.

void CEGUI::Spinner::onValueChanged | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

  | Method called when the spinner value changes. Parameters:
  | e | WindowEventArgs object containing any relevant data.
Returns: Nothing.

void CEGUI::Spinner::setCurrentValue | ( | float | value | ) |

  | Set the current spinner value. Parameters:
  | value | value to be assigned to the Spinner.
Returns: Nothing.

void CEGUI::Spinner::setMaximumValue | ( | float | maxValue | ) |

  | Set the spinner maximum value. Parameters:
  | maxValue | The maximum value to be allowed by the spinner.
Returns: Nothing.

void CEGUI::Spinner::setMinimumValue | ( | float | minVaue | ) |

  | Set the spinner minimum value. Parameters:
  | minVaue | The minimum value to be allowed by the spinner.
Returns: Nothing.

void CEGUI::Spinner::setStepSize | ( | float | step | ) |

  | Set the current step value. Parameters:
  | step | The value added to be the spinner value when the up / down buttons are clicked.
Returns: Nothing.

void CEGUI::Spinner::setTextInputMode | ( | TextInputMode | mode | ) |

  | Set the spinner input / display mode. Parameters:
  | mode | One of the TextInputMode enumerated values indicating the text input / display mode to be used by the spinner.
Returns: Nothing.

virtual bool CEGUI::Spinner::testClassName_impl | ( | const String & | class_name | ) | const`[inline, protected, virtual]`

  | Return whether this window was inherited from the given class name at some point in the inheritance heirarchy. Parameters:
  | class_name | The class name that is to be checked.
Returns: true if this window was inherited from class_name. false if not. Reimplemented from CEGUI::Window.